use context::VulkanContext;

use super::app::App;

mod context;
mod utils;

#[derive(Debug, thiserror::Error)]
pub enum VulkanError {
    #[error("Failed to create vulkan context")]
    FailedToCreateVulkanContext,
}

pub struct Vulkan;

impl Vulkan {
    pub fn new(app: &mut App) -> Result<(), VulkanError> {
        let vulkan_context = VulkanContext::from(app as &App);

        app.world_mut().insert_resource(vulkan_context);

        Ok(())
    }
}
