use std::error::Error;
use winit::event_loop::{ControlFlow, EventLoop};

pub mod core;
pub mod game;
pub mod old_app;

fn main() -> Result<(), impl Error> {
    env_logger::init();

    run_new_app()
    // run_old_app()
}

fn run_new_app() -> Result<(), impl Error> {
    let mut app = core::app::App::default();
    game::init(&mut app);
    app.run()
}

fn run_old_app() -> Result<(), impl Error> {
    let event_loop = EventLoop::new().unwrap();
    event_loop.set_control_flow(ControlFlow::Poll);

    let vulkan_context = old_app::vulkan_context::VulkanContext::from(&event_loop);
    let mut app = old_app::app::App::from(vulkan_context);

    event_loop.run_app(&mut app)
}
